diff -Naur --no-dereference a/ti_config_fragments/defconfig_builder.README b/ti_config_fragments/defconfig_builder.README
--- a/ti_config_fragments/defconfig_builder.README	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/defconfig_builder.README	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,143 @@
+##################################
+# Introduction
+##################################
+
+Using config fragments in the Linux kernel is a supported model in the
+Linux kernel main line.  TI has taken advantage of this model to be able
+to take a base defconfig and add or remove configuration flags based contained
+within a config fragment.  This allows the base defconfig to be left in tact
+and helps facilitate and understanding of what config flags can be enabled
+or disabled.  The config fragments drastically reduces the number of merge
+conflicts when the Linux stable dot release (LTS) is merged back to the
+integration point as well as merges for TI domain trees.
+
+But alas this creates another issue as with the config fragments there is no
+direct defconfig for customers to build just many, many, many options.
+
+Therefore the defconfig_builder script was derived to take a defconfig map file
+and present a command line interface to the customer to to create a standard
+defconfig based off the TI integration branches.  The customer is walked through
+steps and if successful a defconfig will be created in the arch/arm/configs directory
+that can be built.
+
+##################################
+# Usage
+##################################
+
+There is only one option for this script.  This option defines the working
+path to where the Linux kernel resides.
+
+	-w - Location of the TI Linux kernel
+
+Command line Example if building from the working Linux kernel
+top level directory:
+	ti_config_fragments/defconfig_builder.sh -w .
+
+Command line Example if building from the ti_config_fragments directory:
+	defconfig_builder.sh -w ../.
+
+##################################
+# Defconfig Map File
+##################################
+
+The defconfig map file contains the mapping of the defconfig options and the
+assembly instructions for the defconfig to be created.
+
+The file contains keywords and all are *required* to be filled out.
+
+processor: - Defines the processor type if the defconfig is to be processor specific
+type: - Defines the type of build.  Like debug build, LSK build or RT build
+defconfig: - Defines the base defconfig config to append the config fragments to
+config_file: - Defines a file that contains a list of config fragments.  If there is not a list then declare "None" for this field.
+extra_configs: - These are individual config fragments that can be appended to the defconfig by themselves or in addition to
+        the config_file.
+
+Example:
+
+This is an example of an AM335x entry that will create a defconfig only for AM335x
+processors, based on the omap2plus_defconfig.  The defconfig_fragment file adds features 
+that have been enabled in the TI integrated kernel.  The extra_configs will add in the
+debug options as well as undefine all processors that are not AM335x.
+
+processor: AM33xx type: am335x_debug_only defconfig: omap2plus_defconfig config_file: defconfig_fragment extra_configs: ti_config_fragments/debug_options.cfg ti_config_fragments/am33xx_only.cfg 
+
+##################################
+# Defconfig Mapping
+##################################
+
+#Processor Specific Defconfig options
+
+These defconfig options enable the Linux kernel for the targer processor only.  Other processor platforms
+are disabled.  The base for each of these defconfigs is the omap2plus_defconfig contained
+in the arch/arm/configs directory of the kernel.
+
+	TI Base Integrated Kernel:
+		am335x_only - Adds the configs from the files contained in the defconfig_fragment file.
+		am335x_debug_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the debug options from the debug_options.cfg
+		am43x_only - Adds the configs from the files contained in the defconfig_fragment file.
+		am43x_debug_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the debug options from the debug_options.cfg
+		dra7xx_only - Adds the configs from the files contained in the defconfig_fragment file.
+		dra7xx_debug_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the debug options from the debug_options.cfg
+
+	Linaro Stable Kernel builds: (These configurations are only available on the TI LSK branch.)
+		am335x_lsk_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the linaro options from the linaro/configs directory
+		am335x_lsk_debug_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the debug options from the debug_options.cfg as
+		       well as the linaro options from the linaro/configs directory
+		am43x_lsk_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the linaro options from the linaro/configs directory
+		am43x_lsk_debug_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the debug options from the debug_options.cfg as
+		       well as the linaro options from the linaro/configs directory
+		dra7xx_lsk_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the linaro options from the linaro/configs directory
+		dra7xx_lsk_debug_only - Adds the configs from the files contained in the defconfig_fragment file and adds in the debug options from the debug_options.cfg as
+		       well as the linaro options from the linaro/configs directory
+
+	TI Based Real Time Kernel: (These configurations are only available on the TI RT branch.)
+		am335x_rt_only - Adds the configs from the files contained in the rt_defconfig_fragment file.
+		am335x_rt_debug_only - Adds the configs from the files contained in the rt_defconfig_fragment file and adds in the debug options from the debug_options.cfg.
+		am43x_rt_only - Adds the configs from the files contained in the rt_defconfig_fragment file.
+		am43x_rt_debug_only - Adds the configs from the files contained in the rt_defconfig_fragment file and adds in the debug options from the debug_options.cfg.
+		dra7xx_rt_only - Adds the configs from the files contained in the rt_defconfig_fragment file.
+		dra7xx_rt_debug_only - Adds the configs from the files contained in the rt_defconfig_fragment file and adds in the debug options from the debug_options.cfg.
+
+#OMAP2+ Defconfig Options
+
+These defconfig options use the omap2plus_defconfig in the arch/arm/configs directory as the base defconfig.
+These options do not disable any processor's or platforms but add additional features that
+
+	TI Base Integrated Kernel:
+		omap2plus_debug - Takes the omap2plus_defconfig and only adds the debug options from the debug_options.cfg.
+		ti_omap2plus - Adds the configs from the files contained in the defconfig_fragment file.
+		ti_omap2plus_debug - Adds the configs from the files contained in the defconfig_fragment file and adds in the debug options from the debug_options.cfg
+
+	Linaro Stable Kernel builds: (These configurations are only available on the TI LSK branch.)
+		ti_lsk_omap2plus - Adds the configs from the files contained in the defconfig_fragment file and adds in the linaro options from the linaro/configs directory.
+		ti_lsk_omap2plus_debug - Adds the configs from the files contained in the defconfig_fragment file and adds in the debug options from the debug_options.cfg as
+		       well as the linaro options from the linaro/configs directory
+
+	TI Based Real Time Kernel: (These configurations are only available on the TI RT branch.)
+		ti_rt_omap2plus - Adds the configs from the files contained in the rt_defconfig_fragment file.
+		ti_rt_omap2plus_debug - Adds the configs from the files contained in the rt_defconfig_fragment file and adds in the debug options from the debug_options.cfg.
+
+#Keystone Defconfig Options
+
+These defconfig options use the keystone_defconfig in the arch/arm/configs directory as the base defconfig.
+These options do not disable any processor's or platforms but add additional features that
+
+	TI Base Integrated Kernel:
+		base_keystone_debug - Takes the keystone_defconfig and only adds the debug options from the debug_options.cfg.
+		ti_keystone defconfig - Adds the configs from the files contained in the multi_core_defconfig_fragment file.
+		ti_keystone_debug - Adds the configs from the files contained in the multi_core_defconfig_fragment file and
+                       adds in the debug options from the debug_options.cfg.
+
+	Linaro Stable Kernel builds: (These configurations are only available on the TI LSK branch.)
+		ti_lsk_keystone  - Adds the configs from the files contained in the multi_core_defconfig_fragment file and adds in the
+                       linaro options from the linaro/configs directory
+		ti_lsk_keystone_debug_only - Adds the configs from the files contained in the multi_core_defconfig_fragment file and adds in the
+                       debug options from the debug_options.cfg as well as the linaro options from the linaro/configs directory
+
+	TI Based Real Time Kernel: (These configurations are only available on the TI RT branch.)
+		ti_rt_keystone - Adds the configs from the files contained in the rt_defconfig_fragment file.
+		ti_rt_keystone_debug  - Adds the configs from the files contained in the rt_defconfig_fragment file and adds in the debug options from the debug_options.cfg.
+
+
+
+
diff -Naur --no-dereference a/ti_config_fragments/defconfig_builder.sh b/ti_config_fragments/defconfig_builder.sh
--- a/ti_config_fragments/defconfig_builder.sh	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/defconfig_builder.sh	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,242 @@
+#!/bin/bash
+#
+#  defconfig_builder.sh
+#
+#  This will perform a merged based on a file that contains information in the
+#  repos to be merged.
+#
+#  For more information type defconfig_builder.sh -h
+#
+#  Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/
+#  ALL RIGHTS RESERVED
+
+PROCESSOR_TAG="processor:"
+BUILD_TYPE_TAG="type:"
+CONFIG_FRAGMENT_TAG="config-fragment="
+
+set_working_directory()
+{
+	# Sanity checkup kernel build location.
+	if [ ! -d "$WORKING_PATH" ]; then
+		WORKING_PATH=$(pwd)
+	fi
+
+	ORIGINAL_DIR=$(pwd)
+	if [ "$ORIGINAL_DIR" != "$WORKING_PATH" ]; then
+		cd "$WORKING_PATH"
+		WORKING_PATH=$(pwd)
+	fi
+
+	TI_WORKING_PATH="$WORKING_PATH/ti_config_fragments"
+	DEFCONFIG_KERNEL_PATH="$WORKING_PATH/arch/arm/configs"
+	DEFCONFIG_MAP_FILE="$TI_WORKING_PATH/defconfig_map.txt"
+}
+
+prepare_for_exit() {
+	rm -f "$PROCESSOR_FILE"
+	rm -f "$BUILD_TYPE_FILE"
+	exit
+}
+
+get_processors() {
+	TEMP_PROC_FILE=$(mktemp)
+	cat "$DEFCONFIG_MAP_FILE" > "$TEMP_PROC_FILE"
+
+	y=0
+	while true;
+	do
+		PROCESSOR_TEMP=$(grep "$PROCESSOR_TAG" "$TEMP_PROC_FILE" | awk '{print$2}' | head -n 1)
+		if [ -z "$PROCESSOR_TEMP" ]; then
+			break
+		fi
+		if ! grep -qc "$PROCESSOR_TEMP" "$PROCESSOR_FILE"; then
+			y=$((y+1))
+			echo -e '\t'"$y". "$PROCESSOR_TEMP" >> "$PROCESSOR_FILE"
+		fi
+		sed -i "1d" "$TEMP_PROC_FILE"
+	done
+
+	rm "$TEMP_PROC_FILE"
+}
+
+choose_processor() {
+	get_processors
+
+	NUM_OF_PROC=$(wc -l "$PROCESSOR_FILE" | awk '{print$1}')
+	# Force the user to answer.  Maybe the user does not want to continue
+	while true;
+	do
+		cat "$PROCESSOR_FILE"
+		read -p "Please choose which processor to build for or 'q' to exit: " REPLY
+		if [ "$REPLY" = "q" -o "$REPLY" = "Q" ]; then
+			prepare_for_exit
+		elif [ "$REPLY" -gt '0' -a "$REPLY" -le "$NUM_OF_PROC" ]; then
+			CHOOSEN_PROCESSOR=$(grep -w "$REPLY" "$PROCESSOR_FILE" | awk '{print$2}')
+			break
+		else
+			echo -e "\nThis is not a choice try again!\n"
+		fi
+	done
+}
+
+choose_build_type() {
+	TEMP_BT_FILE=$(mktemp)
+	TEMP_BUILD_FILE=$(mktemp)
+
+	grep "$CHOOSEN_PROCESSOR" "$DEFCONFIG_MAP_FILE" | grep "$BUILD_TYPE_TAG" | awk '{print$4}' > "$TEMP_BUILD_FILE"
+
+	y=0
+	while true;
+	do
+		CONFIG_FILE=
+		CONFIG_FRAGMENTS=
+
+		BT_TEMP=$(head -n 1 "$TEMP_BUILD_FILE")
+		if [ -z "$BT_TEMP" ]; then
+			break
+		fi
+		BUILD_DETAILS=$(grep -w "$BT_TEMP" "$DEFCONFIG_MAP_FILE")
+
+		# Check to make sure that the config fragments exist
+		TEMP_EXTRA_CONFIG_FILE=$(echo "$BUILD_DETAILS" | cut -d: -f6)
+		if [ -z "$TEMP_EXTRA_CONFIG_FILE" ]; then
+			CONFIG_FRAGMENTS=
+		else
+			for CONFIG_FRAG in $TEMP_EXTRA_CONFIG_FILE;
+			do
+				if [ ! -e "$CONFIG_FRAG" ]; then
+					CONFIG_FRAGMENTS="N/A"
+				fi
+			done
+		fi
+
+		if ! grep -qc "$BT_TEMP" "$BUILD_TYPE_FILE"; then
+			# If the config file and config fragments are available
+			# add it to the list.
+			CONFIG_FILE=$(echo "$BUILD_DETAILS" | awk '{print$8}')
+			if [ "$CONFIG_FILE" = "None" ]; then
+				CONFIG_FILE=
+			else
+				if [ -e "$TI_WORKING_PATH""/""$CONFIG_FILE" ]; then
+					CONFIG_FILE=
+				fi
+			fi
+			# If the check for the config file and the config fragments
+			# pass then these two variables should be empty.  If
+			# they fail then they should be N/A.
+			if [ -z "$CONFIG_FILE" -a -z "$CONFIG_FRAGMENTS" ]; then
+				y=$((y+1))
+				echo -e '\t'"$y". "$BT_TEMP" >> "$BUILD_TYPE_FILE"
+			fi
+		fi
+		sed -i "1d" "$TEMP_BUILD_FILE"
+	done
+
+	NUM_OF_BUILDS=$(wc -l "$BUILD_TYPE_FILE" | awk '{print$1}')
+	if [ "$NUM_OF_BUILDS" -eq 0 ]; then
+		echo "Sorry no build targets for this configuration.  Are you on the right branch?"
+		prepare_for_exit
+	fi
+
+	# Force the user to answer.  Maybe the user does not want to continue
+	while true;
+	do
+		cat "$BUILD_TYPE_FILE"
+		read -p "Please choose which build or 'q' to exit: " REPLY
+		if [ "$REPLY" = "q" -o "$REPLY" = "Q" ]; then
+			prepare_for_exit
+		elif [ "$REPLY" -gt '0' -a "$REPLY" -le "$NUM_OF_BUILDS" ]; then
+			CHOOSEN_BUILD_TYPE=$(grep -w "$REPLY" "$BUILD_TYPE_FILE" | awk '{print$2}')
+			break
+		else
+			echo -e "\nThis is not a choice try again!\n"
+		fi
+	done
+	rm "$TEMP_BT_FILE"
+	rm "$TEMP_BUILD_FILE"
+}
+
+get_build_details() {
+
+	BUILD_DETAILS=$(grep -w "$CHOOSEN_BUILD_TYPE" "$DEFCONFIG_MAP_FILE")
+	DEFCONFIG=$(echo "$BUILD_DETAILS" | awk '{print$6}')
+	DEFCONFIG="$DEFCONFIG_KERNEL_PATH""/""$DEFCONFIG"
+	CONFIG_FILE=$(echo "$BUILD_DETAILS" | awk '{print$8}')
+	# There may be a need to just build with the config fragments themselves
+	if [ "$CONFIG_FILE" = "None" ]; then
+		CONFIG_FILE=
+	fi
+	TEMP_EXTRA_CONFIG_FILE=$(echo "$BUILD_DETAILS" | cut -d: -f6)
+	for CONFIG_FRAG in $TEMP_EXTRA_CONFIG_FILE;
+	do
+		if [ -e "$CONFIG_FRAG" ]; then
+			EXTRA_CONFIG_FILE="$EXTRA_CONFIG_FILE $CONFIG_FRAG"
+		else
+			echo "$CONFIG_FRAG" does not exist
+		fi
+	done
+}
+
+usage()
+{
+cat << EOF
+
+This script utilizes a map file to create defconfigs for multiple TI
+platforms.
+
+There is only one option for this script.  This option defines the working
+path to where the Linux kernel resides.
+
+	-w - Location of the TI Linux kernel
+
+Command line Example if building from the working Linux kernel
+top level directory:
+	ti_config_fragments/defconfig_builder.sh -w .
+
+Command line Example if building from the ti_config_fragments directory:
+	defconfig_builder.sh -w ../.
+
+EOF
+}
+
+#########################################
+# Script Start
+#########################################
+while getopts "w:" OPTION
+do
+	case $OPTION in
+		w)
+			WORKING_PATH=$OPTARG;;
+		?)
+			usage
+			exit;;
+     esac
+done
+
+trap prepare_for_exit EXIT SIGINT SIGTERM
+
+set_working_directory
+
+if [ ! -e "$DEFCONFIG_MAP_FILE" ]; then
+	echo "No defconfig map file found"
+	exit 1
+fi
+
+PROCESSOR_FILE=$(mktemp)
+BUILD_TYPE_FILE=$(mktemp)
+
+choose_processor
+choose_build_type
+get_build_details
+
+if [ ! -z "$CONFIG_FILE" -a -e "$TI_WORKING_PATH/$CONFIG_FILE" ]; then
+	CONFIGS=$(grep "$CONFIG_FRAGMENT_TAG" "$TI_WORKING_PATH/$CONFIG_FILE" | cut -d= -f2)
+fi
+
+STATUS=$("$WORKING_PATH"/scripts/kconfig/merge_config.sh -m -r "$DEFCONFIG" "$CONFIGS" "$EXTRA_CONFIG_FILE")
+if [ "$?" = "0" ];then
+	echo "Creating defconfig file ""$WORKING_PATH""/arch/arm/configs/""$CHOOSEN_BUILD_TYPE"_defconfig
+	cp .config "$DEFCONFIG_KERNEL_PATH"/"$CHOOSEN_BUILD_TYPE"_defconfig
+else
+	echo "Defconfig creation failed"
+fi
diff -Naur --no-dereference a/ti_config_fragments/defconfig_fragment b/ti_config_fragments/defconfig_fragment
--- a/ti_config_fragments/defconfig_fragment	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/defconfig_fragment	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,6 @@
+use-kernel-config=multi_v7_defconfig
+config-fragment=ti_config_fragments/multi_v7_prune.cfg
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/ipc.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
diff -Naur --no-dereference a/ti_config_fragments/defconfig_merge.sh b/ti_config_fragments/defconfig_merge.sh
--- a/ti_config_fragments/defconfig_merge.sh	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/defconfig_merge.sh	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,536 @@
+#! /bin/bash
+#
+#  defconfig_merge.sh
+#
+#  This script will do a full kernel build with sparse information, clean
+#  the build, rebuild the kernel again.  Upon each build a log will be created
+#  if there are warnings.  Any errors and the whole script exits.
+#
+#  Copyright (C) 2013-14 Texas Instruments Incorporated - http://www.ti.com/
+#  ALL RIGHTS RESERVED
+
+export unix_user=$(whoami)
+export user_home_directory=$(getent passwd "$unix_user" | cut -d: -f6)
+
+BUILD_THREADS=$(grep -c "^processor" /proc/cpuinfo)
+DEFCONFIG=""
+CROSS_COMPILE=""
+WORKING_PATH=""
+LOAD_ADDR=0x80008000
+LOAD_ADDRESS_VALUE=""
+LOGGING_DIRECTORY="working_config"
+
+prepare_for_exit()
+{
+	set_original_directory
+}
+
+check_for_compiler()
+{
+	COMPILER_COMMAND=$(which $CROSS_COMPILE"gcc")
+	if [ -x "$COMPILER_COMMAND" ]; then
+		return 0
+	else
+		echo "Invalid or non-existent compiler $COMPILER_COMMAND" > build_failure.txt
+		return 1
+	fi
+}
+
+build_the_defconfig()
+{
+	BUILD_OUT=$(mktemp)
+	#Check for defconfig issues
+	echo "Making the $DEFCONFIG"
+	cross_make "$DEFCONFIG" > "$BUILD_OUT" 2>&1
+	NUM_OF_ERRORS=$(grep -wc "error:" "$BUILD_OUT")
+	if [ "$NUM_OF_ERRORS" -gt '0' ];then
+		rm "$BUILD_OUT"
+		return 1
+	fi
+
+	NUM_OF_WARNINGS=$(grep -wc "warning:" "$BUILD_OUT")
+	if [ -f "$OUT_LOG" ]; then
+		IS_THIS_LOGGED=$(grep -wc "Defconfig build" "$OUT_LOG")
+		if [ "$IS_THIS_LOGGED" = 0 ]; then
+			{	echo "#########################################################"
+				echo "# $DEFCONFIG Defconfig build                             "
+				echo "#########################################################"
+			} >> "$OUT_LOG"
+			if [ "$NUM_OF_WARNINGS" -gt 0 ]; then
+				echo >> "$OUT_LOG"
+				cat "$DEFCONFIG_OUT" >> "$OUT_LOG"
+			fi
+			{ echo  ""
+				echo  "There are a total of $NUM_OF_WARNINGS warnings in this build"
+				echo ""
+			} >> "$OUT_LOG"
+		fi
+	fi
+
+	rm "$BUILD_OUT"
+}
+
+build_the_new_defconfig()
+{
+	BUILD_OUT=$(mktemp)
+	#Check for defconfig issues
+	echo "Making the $NEW_DEFCONFIG"
+	cross_make "$NEW_DEFCONFIG" > "$BUILD_OUT" 2>&1
+
+	NUM_OF_ERRORS=$(grep -wc "error:" "$BUILD_OUT")
+	if [ "$NUM_OF_ERRORS" -gt '0' ];then
+		rm "$BUILD_OUT"
+		return 1
+	fi
+
+	NUM_OF_WARNINGS=$(grep -wc "warning:" "$BUILD_OUT")
+	if [ -f  "$OUT_LOG" ]; then
+		IS_THIS_LOGGED=$(grep -wc "Defconfig build"  "$OUT_LOG")
+		if [ "$IS_THIS_LOGGED" = 0 ]; then
+			{ echo "#########################################################"
+			echo "# $NEW_DEFCONFIG Defconfig build                         "
+			echo "#########################################################"
+			} >> "$OUT_LOG"
+			if [ "$NUM_OF_WARNINGS" -gt 0 ]; then
+				echo >> "$OUT_LOG"
+				cat "$NEW_DEFCONFIG" >> "$OUT_LOG"
+			fi
+			{ echo  ""
+				echo  "There are a total of $NUM_OF_WARNINGS warnings in this build"
+				echo ""
+			} >> "$OUT_LOG"
+		fi
+	fi
+
+	rm "$BUILD_OUT"
+}
+
+build_the_kernel()
+{
+	BUILD_OUT=$(mktemp)
+	echo "Building the kernel"
+	if [ -n "$LOAD_ADDR" ]; then
+		LOAD_ADDRESS_VALUE="LOADADDR=$LOAD_ADDR"
+	fi
+
+	cross_make "$LOAD_ADDRESS_VALUE" uImage > "$BUILD_OUT" 2>&1
+	#Check for build errors
+	NUM_OF_ERRORS=$(grep -wci "error:" "$BUILD_OUT")
+	if [ "$NUM_OF_ERRORS" -gt '0' ];then
+		cat  "$BUILD_OUT" > "$OUT_LOG"
+		rm  "$BUILD_OUT"
+		return 1
+	fi
+	NUM_OF_WARNINGS=$(grep -wc "warning:" "$BUILD_OUT")
+	{ echo "#########################################################"
+		echo "# Kernel Compiler Warnings"
+		echo "#########################################################"
+	} >> "$OUT_LOG"
+
+	if [ "$NUM_OF_WARNINGS" -gt 0 ]; then
+		echo  >> "$OUT_LOG"
+		grep 'warning:' "$BUILD_OUT" >> "$OUT_LOG"
+	fi
+	{ echo  ""
+		echo  "There are a total of $NUM_OF_WARNINGS warnings in this build"
+		echo ""
+	} >> "$OUT_LOG"
+
+	rm "$BUILD_OUT"
+}
+
+build_the_dtbs()
+{
+	BUILD_OUT=$(mktemp)
+	echo "Building the device tree"
+	cross_make dtbs > "$BUILD_OUT" 2>&1
+	#Check for build errors
+	NUM_OF_ERRORS=$(grep -wci "error:" "$BUILD_OUT")
+	if [ "$NUM_OF_ERRORS" -gt '0' ];then
+		cat "$BUILD_OUT" >> "$OUT_LOG"
+		rm "$BUILD_OUT"
+		return 1
+	fi
+
+	NUM_OF_WARNINGS=$(grep -wc "warning:" "$BUILD_OUT")
+	{	echo "#########################################################"
+		echo "# Device Tree Warnings"
+		echo "#########################################################"
+	}  >> "$OUT_LOG"
+	if [ "$NUM_OF_WARNINGS" -gt 0 ]; then
+		echo  >> "$OUT_LOG"
+		grep 'warning:' "$BUILD_OUT" >> "$OUT_LOG"
+	fi
+	{ echo  ""
+		echo  "There are a total of $NUM_OF_WARNINGS warnings in this build"
+		echo ""
+	} >> "$OUT_LOG"
+
+	rm "$BUILD_OUT"
+}
+
+build_the_modules()
+{
+	BUILD_OUT=$(mktemp)
+	echo "Building the modules"
+	cross_make modules > "$BUILD_OUT" 2>&1
+	#Check for build errors
+	NUM_OF_ERRORS=$(grep -wci "error:" "$BUILD_OUT")
+	if [ "$NUM_OF_ERRORS" -gt '0' ];then
+		cat "$BUILD_OUT" >> "$OUT_LOG"
+		rm "$BUILD_OUT"
+		return 1
+	fi
+
+	NUM_OF_WARNINGS=$(grep -wc "warning:" "$BUILD_OUT")
+	{ echo "#########################################################"
+	  echo "# Module Build Warnings"
+	  echo "#########################################################"
+	} >> "$OUT_LOG"
+	if [ "$NUM_OF_WARNINGS" -gt 0 ]; then
+		echo  >> "$OUT_LOG"
+		grep 'warning:' "$BUILD_OUT" >> "$OUT_LOG"
+	fi
+	{ echo ""
+		echo  "There are a total of $NUM_OF_WARNINGS warnings in the modules"
+		echo  ""
+	} >> "$OUT_LOG"
+
+	cross_make tar-pkg > "$BUILD_OUT" 2>&1
+	#Check for build errors
+	NUM_OF_ERRORS=$(grep -wci "error:" "$BUILD_OUT")
+	if [ "$NUM_OF_ERRORS" -gt '0' ];then
+		cat "$BUILD_OUT" >> "$OUT_LOG"
+		rm "$BUILD_OUT"
+		return 1
+	fi
+
+	rm "$BUILD_OUT"
+}
+
+clean_the_build()
+{
+	cross_make mrproper
+}
+
+setup_directories()
+{
+	SCRIPT_DIR=$(dirname "$0")
+	if [ -n "$WORKING_PATH" ]; then
+		# invoking script for a different kernel...
+		KERNEL_DIR="$WORKING_PATH"
+	else
+		# The script is located in <kernel_dir>/ti_config_fragments directory..
+		# Lets use that trick to find the kernel directory.
+		KERNEL_DIR=$(dirname "$SCRIPT_DIR")
+		WORKING_PATH="$KERNEL_DIR"
+	fi
+
+	# Sanity checkup kernel build location.
+	if [ ! -d "$KERNEL_DIR" ]; then
+		echo "Kernel working dir $KERNEL_DIR is not a directory/ does not exist! exiting.."
+		exit 1
+	fi
+
+	if [ -n "$DEFCONFIG_EXTRAS_FILE" ]; then
+		DEFCONFIG_EXTRAS_DIR=$(dirname "$DEFCONFIG_EXTRAS_FILE")
+		DEFCONFIG_EXTRAS_KERNEL_DIR=$(dirname "$DEFCONFIG_EXTRAS_DIR")
+		DEFCONFIG_EXTRAS_FILE_NAME=$(basename "$DEFCONFIG_EXTRAS_FILE")
+		DEFCONFIG_EXTRAS_FILE="$DEFCONFIG_EXTRAS_DIR/$DEFCONFIG_EXTRAS_FILE_NAME"
+		if [ ! -e "$DEFCONFIG_EXTRAS_FILE" ]; then
+			echo "Kernel fragments file $DEFCONFIG_EXTRAS_FILE does not exist/is not readable!"
+			usage
+			exit 1
+		fi
+		if [ ! -d "$DEFCONFIG_EXTRAS_DIR" ]; then
+			echo "Kernel fragments dir $DEFCONFIG_EXTRAS_DIR does not exist/is not a directory?"
+			usage
+			exit 1
+		fi
+	fi
+
+	# if just the appended config is provided
+	if [ -n "$APPENDED_CONFIG" ]; then
+		APPENDED_CONFIG_DIR=$(dirname "$APPENDED_CONFIG")
+		APPENDED_CONFIG_FILE_NAME=$(basename "$APPENDED_CONFIG")
+		APPENDED_CONFIG="$APPENDED_CONFIG_DIR/$APPENDED_CONFIG_FILE_NAME"
+	fi
+
+}
+
+set_working_directory()
+{
+	ORIGINAL_DIR=$(pwd)
+	if [ "$ORIGINAL_DIR" != "$WORKING_PATH" ]; then
+		cd "$WORKING_PATH"
+	fi
+}
+
+set_original_directory()
+{
+	CURRENT_DIR=$(pwd)
+	if [ "$CURRENT_DIR" != "$ORIGINAL_DIR" ]; then
+		cd "$ORIGINAL_DIR"
+	fi
+}
+
+cross_make()
+{
+	make -C"$KERNEL_DIR" -j"$BUILD_THREADS" ARCH=arm CROSS_COMPILE="$CROSS_COMPILE" "$@"
+}
+
+usage()
+{
+cat << EOF
+This script will either take in a single defconfig fragment file or a
+file with multiple fragments defined.  With either file the base defconfig
+will initially be built, copied to a working directory, and the kernels merge_config
+script will be called for each config file fragment.  Each config file fragment will be appended
+to the base config and then the final output will be copied back to the kernels working
+directory.
+
+A copy of both the base config and the final config is stored in the scripts logging directory.
+
+Single fragment command line example:
+
+	defconfig_merge.sh -c <path to the compiler> -o <path to output log file>
+	-e <path to single fragment file> -w <path to the kernel directory>
+
+Multiple fragment file format:
+"use-kernel-config=" - Is required to be defined.  This is the base defconfig
+that the config fragments will be appended to.  This defconfig should be in the
+Linux kernel path in arch/arm/configs.
+
+	use-kernel-config= < defconfig base to start appending fragments >
+
+"config-fragment=" - Is required to be defined.  There should be at least one
+entry per config fragment.
+
+	config-fragment= < path to the defconfig fragment file 1>
+
+Multiple fragment command line example:
+
+	defconfig_merge.sh -c <path to the compiler> -o <path to output log file>
+	-f <path to multiple fragment file> -w <path to the kernel directory>
+
+Example:
+use-kernel-config=omap2plus_defconfig
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/power.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
+config-fragment=ti_config_fragments/ipc.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/system_test.cfg
+
+
+OPTIONS:
+	Setup Options:
+	-c  The path to the desired compiler
+	-d  The defconfig to use as a base
+	-e  Single defconfig fragment to append
+	-j  How many build threads to use
+	-o  Output log file
+	-l  uImage load address if different from 0x80008000 for no load address use ""
+
+	Build Options:
+	-n  Do not pre-build the defconfig just use the existing .config
+	-m  MAKE the kernel, modules and dtb files based on the new config
+	-w  Linux kernel directory
+
+	-f  Path to file with multiple defconfig options
+
+EOF
+}
+while getopts "c:j:d:e:o:l:f:w:mnb" OPTION
+do
+	case $OPTION in
+		d)
+			DEFCONFIG=$OPTARG;;
+		e)
+			APPENDED_CONFIG=$OPTARG;;
+		c)
+			CROSS_COMPILE=$OPTARG;;
+		j)
+			BUILD_THREADS=$OPTARG;;
+		o)
+			OUT_LOG=$OPTARG;;
+		l)
+			LOAD_ADDR=$OPTARG;;
+		n)
+			NO_CLEAN_DEFCONFIG=1;;
+		m)
+			BUILD_ALL=1;;
+		f)
+			DEFCONFIG_EXTRAS_FILE=$OPTARG;;
+		w)
+			WORKING_PATH=$OPTARG;;
+		?)
+			usage
+			exit;;
+     esac
+done
+
+setup_directories
+trap prepare_for_exit EXIT SIGINT SIGTERM
+
+
+if [ "$BUILD_ALL" == 1 -o "$NO_CLEAN_DEFCONFIG" != 1 ]; then
+	if [ -z "$CROSS_COMPILE" ]; then
+		echo "Missing cross compile"
+		usage
+		exit 1
+	fi
+fi
+
+if [ -z "$DEFCONFIG_EXTRAS_FILE" -a -z "$APPENDED_CONFIG" ]; then
+	echo "Missing config fragment information"
+	usage
+	exit 1
+fi
+
+
+if [ -z  "$OUT_LOG" ]; then
+	echo "Missing output log path, dumping to /dev/null"
+	OUT_LOG=/dev/null
+fi
+
+set_working_directory
+
+LOGGING_DIRECTORY="$WORKING_PATH""/ti_config_fragments/""$LOGGING_DIRECTORY"
+if [ ! -d "$LOGGING_DIRETORY" ];then
+	echo -e "\n\tRemoving $LOGGING_DIRECTORY"
+	rm -rf "$LOGGING_DIRECTORY"
+fi
+
+echo -e "\n\tCreating $LOGGING_DIRECTORY for final configuration files\n"
+mkdir -p "$LOGGING_DIRECTORY"
+
+check_for_compiler
+if [ $? -ne 0 ]; then
+	 echo -e "\n\tCannot find $CROSS_COMPILE compiler\n"
+	 exit 1
+fi
+
+if [ -z "$DEFCONFIG" ];then
+	if [ -n "$DEFCONFIG_EXTRAS_FILE"  ]; then
+		DEFCONFIG=$(grep "use-kernel-config=" "$DEFCONFIG_EXTRAS_FILE" | cut -d= -f2)
+		if [ -z "$DEFCONFIG"  ]; then
+			echo -e "\n\tMissing base defconfig in the file\n"
+			usage
+			exit 1
+		fi
+		echo "Using base config $DEFCONFIG from the file $DEFCONFIG_EXTRAS_FILE"
+	else
+		echo "Missing a defconfig cannot proceed"
+		usage
+		exit 1
+	fi
+fi
+
+DEFCONFIG_EXTRAS="$LOGGING_DIRECTORY/merged_$DEFCONFIG"
+
+if [ "$NO_CLEAN_DEFCONFIG" != 1 ]; then
+	clean_the_build
+	build_the_defconfig
+	if [ $? -ne 0 ]; then
+		 echo "Building $DEFCONFIG failed"
+		 exit 1
+	fi
+else
+	if [ -e ".config" ]; then
+		echo "The .config shows it exists"
+	else
+		echo "The .config did not exist already"
+		exit 1
+	fi
+fi
+
+if [ -a .config ]; then
+	cp -v .config "$LOGGING_DIRECTORY"/base_config
+fi
+
+# There is only one file passed in via command line
+if [ -z "$DEFCONFIG_EXTRAS_FILE" ]; then
+	echo "Only appending $APPENDED_CONFIG"
+	"$KERNEL_DIR"/scripts/kconfig/merge_config.sh -m -r -O "$LOGGING_DIRECTORY" "$LOGGING_DIRECTORY"/base_config "$APPENDED_CONFIG"
+	if [ $? -ne 0 ]; then
+		echo "Failed to merge config $APPENDED_CONFIG"
+		exit 1
+	fi
+else
+	TEMP_FRAGMENT=$(mktemp)
+	grep "config-fragment=" "$DEFCONFIG_EXTRAS_FILE" | cut -d= -f2 > "$TEMP_FRAGMENT"
+	NUM_OF_FRAGMENTS=$(wc -l "$TEMP_FRAGMENT" | awk '{print$1}')
+	if [ -z "$NUM_OF_FRAGMENTS" ]; then
+		echo "Malformed defconfig fragment file"
+		rm "$TEMP_FRAGMENT"
+		exit 1
+	fi
+	cat "$LOGGING_DIRECTORY"/base_config > "$LOGGING_DIRECTORY"/temp_config
+	while read APPENDED_CONFIG
+	do
+		if [ -z "$APPENDED_CONFIG" ]; then
+			break
+		fi
+		if [ ! -r "$APPENDED_CONFIG" ]; then
+			# If not using absolute path, then assume we are relative to kernel dir
+			# of the defconfig_extras
+			APPENDED_CONFIG="$DEFCONFIG_EXTRAS_KERNEL_DIR"/"$APPENDED_CONFIG"
+		fi
+		if [ ! -r "$APPENDED_CONFIG" ]; then
+			echo "Failed to find $APPENDED_CONFIG"
+			usage
+			exit 1
+		fi
+
+		"$KERNEL_DIR"/scripts/kconfig/merge_config.sh -m -r -O "$LOGGING_DIRECTORY" "$LOGGING_DIRECTORY"/temp_config "$APPENDED_CONFIG"
+		if [ $? -ne 0 ]; then
+			echo "Failed to merge config $APPENDED_CONFIG"
+			rm "$TEMP_FRAGMENT"
+			exit 1
+		fi
+		cat "$APPENDED_CONFIG" >> "$DEFCONFIG_EXTRAS"
+		cat "$LOGGING_DIRECTORY"/.config > "$LOGGING_DIRECTORY"/temp_config
+	done < "$TEMP_FRAGMENT"
+	rm "$TEMP_FRAGMENT"
+fi
+
+# The final defconfig to create
+NEW_DEFCONFIG="appended_$DEFCONFIG"
+
+# Last step before the build
+cat "$LOGGING_DIRECTORY"/.config > "$LOGGING_DIRECTORY"/final_config
+echo -e "\n\t Copying $LOGGING_DIRECTORY/.config to $KERNEL_DIR/.config"
+cp -v "$LOGGING_DIRECTORY"/.config "$KERNEL_DIR"/.config
+echo -e "\n\t Copying $LOGGING_DIRECTORY/.config to arch/arm/configs/$NEW_DEFCONFIG"
+cp -v "$LOGGING_DIRECTORY"/.config "$KERNEL_DIR""/arch/arm/configs/""$NEW_DEFCONFIG"
+
+if [ -a "$LOGGING_DIRECTORY"/temp_config ]; then
+	rm "$LOGGING_DIRECTORY"/temp_config
+fi
+
+if [ "$BUILD_ALL" == 1 ]; then
+	build_the_new_defconfig
+	if [ $? -ne 0 ]; then
+		 echo "Building the defconfig failed"
+		 exit 1
+	fi
+
+	build_the_kernel
+	if [ $? -ne 0 ]; then
+		 echo "Building the kernel failed"
+		 exit 1
+	fi
+
+	build_the_dtbs
+	if [ $? -ne 0 ]; then
+		 echo "Building the device tree binaries failed"
+		 exit 1
+	fi
+
+	build_the_modules
+	if [ $? -ne 0 ]; then
+		 echo "Building the modules failed"
+		 exit 1
+	fi
+fi
